//
//  Factorise.cc
//  Factorisation class: factorises integers read from standard input
//
//  Created by Rene Hexel on 20/10/06.
//  Copyright 2006-2008 Rene Hexel. All rights reserved.
//

#include <iostream>
#include <stdio.h>
#include "Factorise.h"

using namespace std;

/**
 * Read factorisation values from standard input and
 * print results on standard output
 */
void Factorise::doIt()
{
	int n;

	while (cin >> n)
	{
		vector<int> factors = factorise(n);
		printFactors(factors, n);
	}
}


/**
 * Factorise a given integer into an array
 */
vector<int> Factorise::factorise(int n)
{
	// create an array for factors
	vector<int> factors;

	int c;
	for (c = 2;  n > 1 && c*c <= n;  c++)
	{
		while (n % c == 0)
		{
			factors.push_back(c);

			n /= c;		// same as:  n = n / c
		}
	}
	
	if (n > 1)
		factors.push_back(n);

	return factors;
}


/**
 * print the factors in the array using printf()
 */
void Factorise::printFactors(vector<int> &factors, int n)
{
	// get an iterator (enumerator)
	vector<int>::iterator e = factors.begin();
	
	printf("%d = ", n);
	
	while (e != factors.end())
	{
		printf("%d", *e);
		
		e++;
		
		if (e != factors.end())
			printf(" . ");
	}
	printf("\n");
}
